'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = connect;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _dropRight = require('lodash/dropRight');

var _dropRight2 = _interopRequireDefault(_dropRight);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _last = require('lodash/last');

var _last2 = _interopRequireDefault(_last);

var _reduce = require('lodash/reduce');

var _reduce2 = _interopRequireDefault(_reduce);

var _reactResolver = require('react-resolver');

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

var injectFalcor = function injectFalcor(WrappedComponent) {
  var displayName = 'Falcor(' + getDisplayName(WrappedComponent) + ')';

  var Connect = function Connect(props, context) {
    var falcor = props.falcor || context.falcor;

    (0, _invariant2.default)(falcor, 'Could not find "falcor" in either the context or ' + ('props of "' + displayName + '". ') + 'Either wrap the root component in a <Provider>, ' + ('or explicitly pass "falcor" as a prop to "' + displayName + '".'));

    return _react2.default.createElement(WrappedComponent, (0, _extends3.default)({ falcor: falcor }, props));
  };
  Connect.displayName = displayName;
  Connect.WrappedComponent = WrappedComponent;
  Connect.propsTypes = {
    falcor: _react.PropTypes.object
  };
  Connect.contextTypes = {
    falcor: _react.PropTypes.object
  };
  return (0, _hoistNonReactStatics2.default)(Connect, WrappedComponent);
};

var reducePathSet = function reducePathSet(r, pathSetOrFunction, prop) {
  r[prop] = function (_ref) {
    var falcor = _ref.falcor;
    var ownProps = (0, _objectWithoutProperties3.default)(_ref, ['falcor']);

    var pathSet = (0, _isFunction2.default)(pathSetOrFunction) ? pathSetOrFunction(ownProps) : pathSetOrFunction;
    if ((0, _isArray2.default)(pathSet)) {
      if ((0, _isArray2.default)((0, _last2.default)(pathSet))) {
        return falcor.get(pathSet).then(function (res) {
          return (0, _get2.default)(res, ['json'].concat((0, _toConsumableArray3.default)((0, _dropRight2.default)(pathSet))));
        });
      }
      return falcor.getValue(pathSet);
    }
    return pathSet;
  };
  return r;
};

function connect(pathSets) {
  return function wrapWithConnect(WrappedComponent) {
    var asyncProps = (0, _reduce2.default)(pathSets, reducePathSet, {});
    return injectFalcor((0, _reactResolver.resolve)(asyncProps)(WrappedComponent));
  };
}